OPT MODULE


->*****
->** External modules
->*****
MODULE 'muimaster' , 'libraries/mui'
MODULE 'tools/boopsi'
MODULE 'utility/tagitem' , 'utility/hooks'


->*****
->** Object definitions
->*****
EXPORT OBJECT app_arexx
	commands :	PTR TO mui_command
	error    :	hook
ENDOBJECT

EXPORT OBJECT app_display
	button_pressed          :	hook
ENDOBJECT

EXPORT OBJECT app_obj
	app                     :	PTR TO LONG
	wi_the_window           :	PTR TO LONG
	bt_put_constant_string  :	PTR TO LONG
	bt_put_variable         :	PTR TO LONG
	bt_return_id            :	PTR TO LONG
	bt_call_hook            :	PTR TO LONG
	tx_result               :	PTR TO LONG
	bt_quit                 :	PTR TO LONG
	stR_TX_result           :	PTR TO CHAR
ENDOBJECT


->*****
->** Constant definitions
->*****
EXPORT ENUM
	ID_BUTTON_PRESSED = 1


->*****
->** Global variable definitions
->*****
EXPORT DEF string_var


/*************************************************************************
** Method to create one instance of one object or the whole application **
*************************************************************************/
PROC create( display : PTR TO app_display ,
             icon  = NIL ,
             arexx = NIL : PTR TO app_arexx ,
             menu  = NIL ) OF app_obj

	DEF grOUP_ROOT_0C , gr_grp_0 , gr_grp_1 , la_result , gr_grp_2

	self.stR_TX_result           := 'Zzzzzzzzzzzzz'

	self.bt_put_constant_string := Mui_MakeObjectA(MUIO_Button,[ 'Put _Constant String' ])

	self.bt_put_variable := Mui_MakeObjectA(MUIO_Button,[ 'Put _Variable' ])

	self.bt_return_id := Mui_MakeObjectA(MUIO_Button,[ '_Return ID' ])

	self.bt_call_hook := Mui_MakeObjectA(MUIO_Button,[ 'Call _Hook' ])

	la_result := Mui_MakeObjectA(MUIO_Label,[ 'Result' ,0])

	self.tx_result := Mui_NewObjectA('Text.mui',[TAG_IGNORE,0 ,
		MUIA_HelpNode , 'TX_result' ,
		MUIA_Frame , MUIV_Frame_Text ,
		MUIA_Text_Contents , self.stR_TX_result ,
		MUIA_Text_SetMin , MUI_TRUE ,
	TAG_DONE])

	gr_grp_1 := Mui_NewObjectA('Group.mui',[TAG_IGNORE,0 ,
		MUIA_Group_Horiz , MUI_TRUE ,
		MUIA_Group_Child , la_result ,
		MUIA_Group_Child , self.tx_result ,
	TAG_DONE])

	gr_grp_0 := Mui_NewObjectA('Group.mui',[TAG_IGNORE,0 ,
		MUIA_Frame , MUIV_Frame_Group ,
		MUIA_FrameTitle , 'Click !' ,
		MUIA_Group_Child , self.bt_put_constant_string ,
		MUIA_Group_Child , self.bt_put_variable ,
		MUIA_Group_Child , self.bt_return_id ,
		MUIA_Group_Child , self.bt_call_hook ,
		MUIA_Group_Child , gr_grp_1 ,
	TAG_DONE])

	self.bt_quit := Mui_MakeObjectA(MUIO_Button,[ '_Quit' ])

	gr_grp_2 := Mui_NewObjectA('Group.mui',[TAG_IGNORE,0 ,
		MUIA_Group_Child , self.bt_quit ,
	TAG_DONE])

	grOUP_ROOT_0C := Mui_NewObjectA('Group.mui',[TAG_IGNORE,0 ,
		MUIA_Group_Child , gr_grp_0 ,
		MUIA_Group_Child , gr_grp_2 ,
	TAG_DONE])

	self.wi_the_window := Mui_NewObjectA('Window.mui',[TAG_IGNORE,0 ,
		MUIA_Window_Title , 'The window !' ,
		MUIA_HelpNode , 'WI_the_window' ,
		MUIA_Window_ID , "0WIN" ,
		MUIA_Window_RootObject , grOUP_ROOT_0C ,
	TAG_DONE])

	self.app := Mui_NewObjectA('Application.mui',[TAG_IGNORE,0 ,
		( IF icon THEN MUIA_Application_DiskObject ELSE TAG_IGNORE ) , icon ,
		( IF arexx.commands THEN MUIA_Application_Commands ELSE TAG_IGNORE ) , arexx.commands ,
		( IF arexx.error THEN MUIA_Application_RexxHook ELSE TAG_IGNORE ) , arexx.error ,
		( IF menu THEN MUIA_Application_Menu ELSE TAG_IGNORE ) , menu ,
		MUIA_Application_Author , 'Lionel Vintenat' ,
		MUIA_Application_Base , 'DEMOGENCODEE' ,
		MUIA_Application_Title , 'DemoGenCodeE' ,
		MUIA_Application_Version , '$VER: DemoGenCodeE 1.0 (01.09.94)' ,
		MUIA_Application_Copyright , 'Public Domain !' ,
		MUIA_Application_Description , 'Application example for GenCodeE' ,
		MUIA_Application_Window , self.wi_the_window ,
	TAG_DONE])

ENDPROC self.app


/**********************************************************
** Method to dispose the object or the whole application **
**********************************************************/
PROC dispose() OF app_obj IS Mui_DisposeObject( self.app )


/*****************************************************************************************
** Method to initialize all the notifications of one object or of the whole application **
*****************************************************************************************/
PROC init_notifications( display : PTR TO app_display ) OF app_obj

	domethod( self.bt_put_constant_string , [
		MUIM_Notify , MUIA_Pressed , FALSE ,
		self.tx_result ,
		3 ,
		MUIM_Set , MUIA_Text_Contents , 'Constant string put !' ] )

	domethod( self.bt_put_variable , [
		MUIM_Notify , MUIA_Pressed , FALSE ,
		self.tx_result ,
		3 ,
		MUIM_Set , MUIA_Text_Contents , string_var ] )

	domethod( self.bt_return_id , [
		MUIM_Notify , MUIA_Pressed , FALSE ,
		self.app ,
		2 ,
		MUIM_Application_ReturnID , ID_BUTTON_PRESSED ] )

	domethod( self.bt_call_hook , [
		MUIM_Notify , MUIA_Pressed , FALSE ,
		self.app ,
		2 ,
		MUIM_CallHook , display.button_pressed ] )

	domethod( self.bt_quit , [
		MUIM_Notify , MUIA_Pressed , FALSE ,
		self.app ,
		2 ,
		MUIM_Application_ReturnID , MUIV_Application_ReturnID_Quit ] )

	domethod( self.wi_the_window , [
		MUIM_Window_SetCycleChain , self.bt_put_constant_string ,
		self.bt_put_variable ,
		self.bt_return_id ,
		self.bt_call_hook ,
		self.tx_result ,
		self.bt_quit ,
		0 ] )

	SetAttrsA( self.wi_the_window ,[Eval(`(		MUIA_Window_Open )), MUI_TRUE ,TAG_DONE])

ENDPROC


